public class Liste{
    
    private int val;
    private Liste suiv;
    
    public Liste(){ // liste vide avec sentinelle
	val = 0; 
	suiv = null;	
    }
    
    public Liste(int a){
	Liste x = new Liste(a, null);
        val = 0;
        suiv = x;
    }

    private Liste (int a, Liste x){
        val = a; 
	suiv = x;
    }
    
    public boolean estVide(){
	return suiv == null;
    }
    
    public int valeur() {
        if (estVide()) 
	    throw new RuntimeException("Valeur pour une  liste vide");
	return suiv.val;
    }
    
    public Liste reste(){
        if (estVide()) 
	    throw new RuntimeException("Reste pour une  liste vide");
        return suiv;
    }
    
    public void ajoutDebut(int a){
        Liste x = new Liste(a, suiv);
        this.suiv = x;
    }
    
    public void ajoutFin (int a){
	if (estVide()) 
	    ajoutDebut(a);
	else 
	    reste().ajoutFin(a);
    }
 
    public void supprimer (int a){
        Liste x = this;
        boolean trouve = false;
        while (!trouve && x.suiv != null ){
	    if (x.suiv.val == a) {
		trouve = true;
		x.suiv = x.suiv.suiv;
            }
            x = x.suiv;
	}
    }

    public int longueur(){
        return estVide() ? 0: 1 + reste().longueur();
    }
    
    public boolean appartient (int a){
        if (estVide()) 
	    return false;
        else if (valeur() == a) 
	    return true;
        else 
	    return reste().appartient(a);
    }

    public String toString(){
        if (estVide()) 
	    return "-> ";
        else
	    return "-> " + valeur() + reste().toString();
    }

}
